<?php
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

#   PNP Template for check_tcp_connections.sh
#   Author: Pavel aka Rascal (http://rascal.su/)

$green = "33FF00E0";
$yellow = "FFFF00E0";
$red = "F83838E0";
$now = "FF00FF";
$blue = "6600FF";
$grey = "666666";
$purple = "800080";
$violet = "EE82EE";
$black = "000000";
$pink = "FFC0CB";

$opt[1]  = "--vertical-label 'Num' -l0 --title \"TCP Connections status for $hostname\" ";
$def[1]  = "DEF:established=$RRDFILE[1]:$DS[1]:AVERAGE " ;
$def[1] .= "DEF:listen=$RRDFILE[1]:$DS[2]:AVERAGE " ;
$def[1] .= "DEF:synsent=$RRDFILE[1]:$DS[3]:AVERAGE " ;
$def[1] .= "DEF:synrecv=$RRDFILE[1]:$DS[4]:AVERAGE " ;
$def[1] .= "DEF:finw1=$RRDFILE[1]:$DS[5]:AVERAGE " ;
$def[1] .= "DEF:finw2=$RRDFILE[1]:$DS[6]:AVERAGE " ;
$def[1] .= "DEF:closew=$RRDFILE[1]:$DS[7]:AVERAGE " ;
$def[1] .= "DEF:timew=$RRDFILE[1]:$DS[8]:AVERAGE " ;
$def[1] .= "DEF:lastack=$RRDFILE[1]:$DS[9]:AVERAGE " ;
$def[1] .= "DEF:closing=$RRDFILE[1]:$DS[10]:AVERAGE " ;
$def[1] .= "AREA:listen#$blue:\"LISTEN\" " ;
$def[1] .= "AREA:established#$green:\"ESTABLISHED\":STACK  " ;
$def[1] .= "AREA:timew#$yellow:\"TIME-WAIT\":STACK  " ;
$def[1] .= "AREA:closew#$red:\"CLOSE-WAIT\":STACK  " ;
$def[1] .= "AREA:synsent#$now:\"SYN-SENT\":STACK  " ;
$def[1] .= "AREA:synrecv#$grey:\"SYN-RECV\":STACK  " ;
$def[1] .= "AREA:finw1#$purple:\"FIN-WAIT-1\":STACK  " ;
$def[1] .= "AREA:finw2#$violet:\"FIN-WAIT-2\":STACK  " ;
$def[1] .= "AREA:lastack#$black:\"LAST-ACK\":STACK  " ;
$def[1] .= "AREA:closing#$pink:\"CLOSING\":STACK  " ;
$def[1] .= "COMMENT:\" \\n\" " ;
$def[1] .= "GPRINT:listen:LAST:\"\tLISTEN\tCur %.0lf \" " ;
$def[1] .= "GPRINT:listen:AVERAGE:\"\tAvg %.0lf \" " ;
$def[1] .= "GPRINT:listen:MAX:\"\tMax %.0lf \\n\" " ;
$def[1] .= "GPRINT:established:LAST:\"\tESTABLISHED\tCur %.0lf \" " ;
$def[1] .= "GPRINT:established:AVERAGE:\"\tAvg %.0lf \" " ;
$def[1] .= "GPRINT:established:MAX:\"\tMax %.0lf \\n\" " ;
$def[1] .= "GPRINT:timew:LAST:\"\tTIME-WAIT\tCur %.0lf \" " ;
$def[1] .= "GPRINT:timew:AVERAGE:\"\tAvg %.0lf \" " ;
$def[1] .= "GPRINT:timew:MAX:\"\tMax %.0lf \\n\" " ;
$def[1] .= "GPRINT:closew:LAST:\"\tCLOSE-WAIT\tCur %.0lf \" " ;
$def[1] .= "GPRINT:closew:AVERAGE:\"\tAvg %.0lf \" " ;
$def[1] .= "GPRINT:closew:MAX:\"\tMax %.0lf \\n\" " ;
$def[1] .= "GPRINT:synsent:LAST:\"\tSYN-SENT\tCur %.0lf \" " ;
$def[1] .= "GPRINT:synsent:AVERAGE:\"\tAvg %.0lf \" " ;
$def[1] .= "GPRINT:synsent:MAX:\"\tMax %.0lf \\n\" " ;
$def[1] .= "GPRINT:synrecv:LAST:\"\tSYN-RECV\tCur %.0lf \" " ;
$def[1] .= "GPRINT:synrecv:AVERAGE:\"\tAvg %.0lf \" " ;
$def[1] .= "GPRINT:synrecv:MAX:\"\tMax %.0lf \\n\" " ;
$def[1] .= "GPRINT:finw1:LAST:\"\tFIN-WAIT-1\tCur %.0lf \" " ;
$def[1] .= "GPRINT:finw1:AVERAGE:\"\tAvg %.0lf \" " ;
$def[1] .= "GPRINT:finw1:MAX:\"\tMax %.0lf \\n\" " ;
$def[1] .= "GPRINT:finw2:LAST:\"\tFIN-WAIT-2\tCur %.0lf \" " ;
$def[1] .= "GPRINT:finw2:AVERAGE:\"\tAvg %.0lf \" " ;
$def[1] .= "GPRINT:finw2:MAX:\"\tMax %.0lf \\n\" " ;
$def[1] .= "GPRINT:lastack:LAST:\"\tLAST-ACK\tCur %.0lf \" " ;
$def[1] .= "GPRINT:lastack:AVERAGE:\"\tAvg %.0lf \" " ;
$def[1] .= "GPRINT:lastack:MAX:\"\tMax %.0lf \\n\" " ;
$def[1] .= "GPRINT:closing:LAST:\"\tCLOSING\tCur %.0lf \" " ;
$def[1] .= "GPRINT:closing:AVERAGE:\"\tAvg %.0lf \" " ;
$def[1] .= "GPRINT:closing:MAX:\"\tMax %.0lf \\n\" " ;
